<template>
    <div>
        <div class="section">
            <h1>My Groups</h1>
            <div v-if="MyLoaded">
                <div v-if="HaveMy">
                    <GroupSearchResult v-for="group in MyGroups" :group-value="group" :key="group.unique_key"></GroupSearchResult>
                </div>
                <div v-else class="no-star">
                    You have not created any templates. <br>
                    Look at our
                    <router-link to="/search/Template/">get started</router-link>
                    to quickly
                    create your first template?
                </div>
            </div>
            <div class='error' v-else-if="MyError">
                Oops, something went wrong :<
            </div>
            <div v-else>
                <Loader :s="120" class="load"></Loader>

            </div>

        </div>
        <div class="section">
            <h1>Starred Groups</h1>
            <div v-if="StarLoaded">
                <div v-if="HaveStar">
                    <GroupSearchResult v-for="group in StarGroups" :group-value="group" :key="group.unique_key"></GroupSearchResult>
                </div>
                <div v-else class="no-star">
                    You have no starred groups.
                    <router-link to="/search/Group/">Browse for some?</router-link>
                </div>
            </div>
            <div class='error' v-else-if="StarError">
                Oops, something went wrong :<
            </div>
            <div v-else>
                <Loader :s="120" class="load"></Loader>
            </div>
        </div>
    </div>
</template>

<style lang='scss' scoped>
    .no-star {
        font-family: Roboto, sans-serif;
        font-size: 20px;
        text-align: center;
        padding: 50px;

        a {
            text-decoration: underline;
        }
    }

    .load {
        width: 100%;
        height: 30vh;
    }

    h1 {
        display: block;
        position: relative;
        font-family: Raleway, sans-serif;
        font-weight: 800;
        font-size: 25px;
        margin: 10px 0;
    }

    .section {
        position: relative;
        padding: 30px;
        background: #eeeeee;
        margin: 20px 0;
        border-radius: 10px;
    }
</style>

<script lang='ts'>
	import {Component, Vue} from 'vue-property-decorator';
	import TemplateSearchResult from "../Search/TemplateSearchResult.vue";
	import Loader from "../../components/Loader.vue";
	import {CyanPrintSDK} from "../../../../classLibrary/CyanPrintSDK";
	import GroupSearchResult from "../Search/GroupSearchResult.vue";
	import {GroupData} from "../../../../classLibrary/GroupData";

	@Component({components: {GroupSearchResult, TemplateSearchResult, Loader}})
	export default class ProfileGroup extends Vue {
		private myGroups: GroupData[] = [];
		private starGroups: GroupData[] = [];
		private myLoaded: boolean = false;
		private starLoaded: boolean = false;
		private myError: boolean = false;
		private starError: boolean = false;

		get MyLoaded(): boolean { return this.myLoaded; }

		get StarLoaded(): boolean { return this.starLoaded; }

		get MyError(): boolean { return this.myError; }

		get StarError(): boolean { return this.starError; }

		get HaveStar(): boolean { return this.starGroups.length > 0; }

		get HaveMy(): boolean { return this.myGroups.length > 0; }

		get MyGroups(): GroupData[] {
			return this.myGroups;
		}

		get StarGroups(): GroupData[] {
			return this.starGroups;
		}

		async mounted() {
			await Promise.all([
				this.LoadMyGroup(),
				this.LoadStarGroups()
			]);
		}

		async LoadStarGroups(): Promise<void> {
			const group = await this.$api.GetUserStarredGroup();
			if (group as any === CyanPrintSDK.error) {
				this.starError = true;
			} else {
				this.starGroups = group;
				this.starLoaded = true;
			}
		}

		async LoadMyGroup(): Promise<void> {
			const group = await this.$api.GetUserGroup();
			if (group as any === CyanPrintSDK.error) {
				this.myError = true;
			} else {
				this.myGroups = group;
				this.myLoaded = true;
			}
		}

	}
</script>
